<script setup lang="ts">
import { onClickOutside } from '@vueuse/core'
import { storeToRefs } from 'pinia'
import _ from 'lodash'
import { usePollStore } from '~/store/poll'
import { useAccountStore } from '~~/store/account'

const poll = usePollStore()
const account = useAccountStore()
const { full } = storeToRefs(account)
const { pollInput } = storeToRefs(poll)
const startPoll = () =>
  poll.$patch({
    pollInput: true,
    inputId: '',
    inputQuestion: '',
    inputAnswer: ['', ''],
  })
const { data, availablePoll } = storeToRefs(poll)
const scroll = ref<HTMLElement | null>(null)
const target = ref(null)
onClickOutside(target, () => poll.$patch({ pollInput: false }))

// scroll
const scrollBottom = () => {
  setTimeout(() => {
    if (scroll.value)
      scroll.value.scrollTop = scroll.value.scrollHeight
  })
}
watch(
  () => _.size(data.value),
  scrollBottom,
)
onMounted(() => {
  scrollBottom()
})

// poll notify
const notifyEvent = inject('notifyEvent') as any[]
watch(
  () => _.size(availablePoll.value),
  (value, oldValue) => {
    if (value - oldValue > 0 && notifyEvent)
      notifyEvent.push({ tab: 'poll', value: value - oldValue })
  },
)
</script>

<template>
  <div class="h-full flex flex-col p-2 relative">
    <MPollInput v-if="pollInput" ref="target" :full="full" />
    <div v-if="full" class="flex p-2">
      <button class="bg-blue-500 text-white border px-4 py-1 rounded text-lg ml-auto" @click="startPoll">
        新規作成
      </button>
    </div>
    <div class="flex-1 relative">
      <div v-if="!full && _.every(data, data => data.stop === true)" class="overlay px-5 flex items-center justify-center text-center h-full">
        <p>現在、回答するアンケートはありません。<br></p>
      </div>
      <div v-if="full && _.size(data) === 0" class="overlay px-5 flex justify-center items-center text-center h-full">
        <p>
          アンケートは未作成です。作成する場合、新規作成より作成ください。<br>
          <span class="block h-5" />
          ※作成後、すぐに送信はされません。
        </p>
      </div>
      <div ref="scroll" class="flex flex-col pt-1 absolute top-0 left-0 w-full h-full overflow-auto scrollBar">
        <MPollDetail />
      </div>
    </div>
  </div>
</template>

<style scoped></style>

